var Timer = Backbone.Model.extend({
    initialize: function(options) {
        _.bindAll(this, "tick");
        this.duration = 0;
        this.time_past = 0;
        /* ProTip: use a prime number to simulate randomness */
        this.precision = 41;
        this.running = false;
    },
    set: function(seconds) {
        this.stop();
        this.duration = seconds*1000;
        this.trigger('set');
    },
    start: function() {
        this.running = true;
        if (this.timeover) {
            this.time_past = 0;
        }
        this.timeover = false;
        this.trigger('start');
        this.pid = setInterval(
            this.tick, this.precision
        );
    },
    pause: function() {
        clearInterval(this.pid);
        this.running = false;
        this.trigger('pause');
    },
    stop: function() {
        clearInterval(this.pid);
        this.running = false;
        this.time_past = 0;
        this.trigger('stop');
    },
    tick: function() {
        this.time_past += this.precision;
        if (this.remaining() <= 0) {
            this.time_past = this.duration;
            this.timeover = true;
            this.pause();
            this.trigger('end');
			this.html="<audio autoplay=\"autoplay\"><source src=\"assets/audio/gong.mp3\" type=\"audio/mpeg\"><source src=\"assets/audio/gong.ogg\" type=\"audio/ogg\"></audio>";
			$("#timer").append(this.html)
        }
        this.trigger('tick');
    },
    remaining: function() {
        return new Date(this.duration - this.time_past);
    }
});
