var FaceView = Backbone.View.extend({
    template: _.template($("#face_template").html()),
    audioPlayer_template: _.template($("#audioPlayer_template").html()),
    videoPlayer_template: _.template($("#videoPlayer_template").html()),

    initialize: function(options) {
        this.parentView = options.parentView;
		this.consegna=this.model.get('consegnaCard');
        this.deck = this.parentView.parentView;
        this.side = options.side;
        this.type = this.model.get(this.side).type;
        this.content = this.model.get(this.side).content;
		this.extra = this.model.get(this.side).extra;
        _.bindAll(this, "showContent", "hideContent", "centerContent");

        this.parentView.on("flip:"+this.side+":start", this.hideContent, this);
        this.parentView.on("flip:"+this.side+":end", this.show, this);
        this.parentView.on("slide:end:"+this.side, this.showContent, this);
        this.parentView.on("slide:start:"+this.side, this.hideContent, this);
        this.parentView.on("show:"+this.side, this.show, this);
        this.parentView.on("hide", this.hide, this);
    },
    render: function() {
        if(this.side=='front')
		{
			$(this.el).append("<div id=\"consegnaCard\">"+this.consegna+"</div>") 
		}
		var html = this.template({
            type: this.type,
        });
		$(this.el).append(html);
        el = this.render_content_map[this.type](this.content, this)
        this.$('.content').append(el);
        this.centerContentPID = setInterval(this.centerContent, 250);
		
// LUCIANO - Height of the card		
		altezzaW = $(window).height();
		altezzaC = altezzaW - 350;
		this.$(".faceShadowWrapper").css("height",altezzaC);
		this.$(".faceShadowWrapper .content.image").css("height",altezzaC);
// LUCIANO - End

		return this;
    },
    render_content_map: {
        'html': function(content, view) {
            return content;
        },
        'text': function(content, view) {
            return '<h1>'+content+'</h1>';
        },
        'image': function(content, view, extra) {
            return '<img src="'+content+'" alt="" /><p>'+view.extra+'</p>';
        },
        'audio': function(content, view, extra) {
            cssSelectorAncestor = 'jp_container_' + view.model.get('id');
            playerId = 'jquery_jplayer_' + view.model.get('id');
            el = view.audioPlayer_template({
                'cssSelectorAncestor': cssSelectorAncestor,
                'content': view.content+".mp3",
                'playerId': playerId,
				'extra': view.extra
            });
            return $(el);
        },
        'video': function(content, view, extra) {
            return $('<div id="videoPlayer_' + view.model.get('id') + '"></div><p>'+view.extra+'</p>');
        }
    },
    showContent: function() {
        return this.show_content_map[this.type](this);
        this.centerContent();
        return content;
    },
    centerContent: function() {
	    	this.$('.content').vAlign();
    },
    show_content_map: {
        'html': function(view) {
        },
        'text': function(view) {
        },
        'image': function(view) {
        },
        'audio': function(view) {
            playerEl = $('#jquery_jplayer_' + view.model.get('id'));
            playerEl.data('view', view);
            playerEl.parent().removeClass('hide');
            cssSelectorAncestor = 'jp_container_' + view.model.get('id');
            playerEl.jPlayer({
                play: function() { // To avoid both jPlayers playing together.
                    $(this).jPlayer("pauseOthers");
                    if (config.get('pauseOnMedia')) {
                        $(this).data('view').deck.timer.pause();
                    }
                },
                ready: function(e) {
                    $(this).jPlayer("setMedia", {
                        'mp3': $(this).data('content')
                    });
                },
                error: function(e) {
                    console.log(e.jPlayer.error);
                },
                'swfPath': "js/libs",
                'supplied': "mp3",
                'cssSelectorAncestor': '#'+cssSelectorAncestor
            });
        },
        'video': function(view) {
            playerEl = $('#videoPlayer_' + view.model.get('id'));
            new VideoPlayerView({
                el: playerEl,
                fileName: view.content,
                parentView: view
            }).render();

        }
    },
    hideContent: function() {
        return this.hide_content_map[this.type](this);
    },
    hide_content_map: {
        'html': function(view) {
        },
        'text': function(view) {
		},
        'image': function(view) {
        },
        'audio': function(view) {
            playerEl = $('#jquery_jplayer_' + view.model.get('id'));
            playerEl.jPlayer('destroy');
            playerEl.parent().addClass('hide');
        },
        'video': function(view) {
            playerEl = $('#videoPlayer_' + view.model.get('id'));
            $(playerEl).empty();
        }
    },
    show: function() {
        $(this.el).removeClass('hide');
        this.showContent();
    },
    hide: function() {
        $(this.el).addClass('hide');
        this.hideContent();
    },
    stopPropagation: function(e) {
        e.stopPropagation();
    }
});
