var PaginatorView = Backbone.View.extend({
    events: {
        "click .next": "nextCard",
        "click .previous": "previousCard"
    },
    initialize: function(options) {
        this.parentView = options.parentView;
		total = this.parentView.collection.length;
		$('#tot').append(total);
        this.collection.on('index:current:set', this.enableButtons, this);
        this.enableButtons();
        this.parentView.on('rendered', this.setIntervalVAlign, this);
        _.bindAll(this, "dispatchKeyUp", "centerPager", "swiped");
        $('body').bind('keyup', this.dispatchKeyUp);
        this.on('keyup', this.onKeyUp, this);
        $(document).on('swipeone', this.swiped);

    },
    setIntervalVAlign: function() {
        this.centerPagerPID = setInterval(this.centerPager, 250);
    },
    centerPager: function() {
        mtop = ($(this.parentView.el).find('.cards').height() - 64) / 2;
        //$(this.el).css('margin-top', mtop);
        this.show();
    },
    show: function() {
        $(this.el).show();
    },
    hide: function() {
        $(this.el).hide();
    },
    dispatchKeyUp: function(e) {
        this.trigger('keyup', e);
    },
    onKeyUp: function(e) {
        if ($(this.el).is(":visible")) {
            if (e.keyCode == 39) {
                this.nextCard(e);
            } else if (e.keyCode == 37) {
                this.previousCard(e);
            }
        }
    },
    swiped: function(type, e) {
        direction = e.description.split(':')[2];
        type.preventDefault();
        if (direction == 'left') {
            this.nextCard(e)
        } else if (direction == 'right') {
            this.previousCard(e)
        }
    },
    nextCard: function(e) {
        if (e.preventDefault) {
            e.preventDefault();
        }
        if (!this.parentView.moving) {
            this.collection.next();            
        }
    },
    previousCard: function(e) {
        if (e.preventDefault) {
            e.preventDefault();
        }
        if (!this.parentView.moving) {
            this.collection.previous();
        }
    },
    enableButtons: function() {
        if (this.collection.currentIndex == 0) {
            this.$('.previous').addClass('disabled');
        } else {
            this.$('.previous').removeClass('disabled');
        }
        if (this.collection.currentIndex == (this.collection.length-1)) {
            this.$('.next').addClass('disabled');
        } else {
            this.$('.next').removeClass('disabled');
        }
    }
});
