var TimerView = Backbone.View.extend({
    initialize: function(options) {
        this.parentView = options.parentView;
        this.parentView.on('card:load', this.setFaceTimer, this);
        this.parentView.on("card:flip", this.setFaceTimer, this);

        this.model.on('tick', this.updateCountDown, this);
        this.model.on('set', this.updateCountDown, this);
        this.model.on('set', this.onSetTime, this);
        this.model.on('end', this.onTimeOver, this);
        this.model.on('start', this.onStartTime, this);
        this.model.on('pause', this.onPauseTime, this);
        this.model.on('stop', this.onStopTime, this);
        this.timerButton = new TimerButtonView({
            parentView: this,
            el: this.$('#timerBtn'),
            model: this.model
        });
        this.updateCountDown();
    },
    show: function() {
        this.updateCountDown();
        $(this.el).show();
    },
    hide: function() {
        $(this.el).hide();
    },
    updateCountDown: function(e) {
        remaining = this.model.remaining();
        this.$('#seconds').text(sprintf("%02d", remaining.getSeconds()));
        this.$('#milliseconds').text(sprintf("%02d", remaining.getMilliseconds()/10));
    },
    onSetTime: function() {
        $(this.el).removeClass('running timeOver');
    },
    onTimeOver: function() {
        $(this.el).removeClass('running').addClass('timeOver');
    },
    onStartTime: function() {
        $(this.el).removeClass('timeOver').addClass('running');
    },
    onPauseTime: function() {
        $(this.el).removeClass('running');
    },
    onStopTime: function() {
        $(this.el).removeClass('running');
    },
    setFaceTimer: function() {
        side = this.parentView.currentCardView().side;
        this.model.set(config.get(side+'Time'));
        if (config.get('autoStart')) {
            this.model.start();
        }
    }
});
